"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createContext = void 0;
var React = require("react");
var symbolObservable_1 = require("./utils/symbolObservable");
var idFn = function (a) { return a; };
function createUnimplemented(objectName) {
    return function unimplemented(methodName) {
        var prefix = objectName ? objectName + "." : "";
        // eslint-disable-next-line @typescript-eslint/no-unused-vars
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            throw new Error("Unimplemented method: " + prefix + methodName);
        };
    };
}
function createContext(rootReducer, preloadedState, displayName) {
    var _a;
    var unimplemented = createUnimplemented("Context(" + (displayName !== null && displayName !== void 0 ? displayName : "") + ")");
    var Context = React.createContext((_a = {
            dispatch: idFn,
            reducer: rootReducer,
            state: preloadedState
        },
        _a[symbolObservable_1.SymbolObservable] = unimplemented(symbolObservable_1.SymbolObservable.toString()),
        _a));
    if (displayName) {
        Context.displayName = displayName;
    }
    return Context;
}
exports.createContext = createContext;
