"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRootDuck = void 0;
var combineReducers_1 = require("./utils/combineReducers");
function createRootDuck() {
    var ducks = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        ducks[_i] = arguments[_i];
    }
    var _a = ducks.reduce(function (acc, duck) {
        acc.names.add(duck.name);
        acc.actions[duck.name] = duck.actions;
        acc.selectors[duck.name] = duck.selectors;
        acc.reducerMapping[duck.name] = duck.reducer;
        acc.initialState[duck.name] = duck.initialState;
        return acc;
    }, {
        actions: {},
        initialState: {},
        names: new Set(),
        reducerMapping: {},
        selectors: {},
    }), actions = _a.actions, initialState = _a.initialState, names = _a.names, reducerMapping = _a.reducerMapping, selectors = _a.selectors;
    var reducer = combineReducers_1.combineReducers(initialState, reducerMapping);
    return {
        actions: actions,
        initialState: initialState,
        names: names,
        reducer: reducer,
        selectors: selectors,
    };
}
exports.createRootDuck = createRootDuck;
